PteroEngine II - editor

PteroEngine II souží k vytváření scén pro hru Vietcong.

Tato verze editoru je určena pouze k vytváření MP scén a nepodporuje žádný druh mobilní techniky.

Otázky ohledně práce s editorem a přípravě scén ve 3ds max můžete psát na email: editor@pterodon.com.

Klávesové zkratky
Příprava modelů ve 3ds max 5.1
Práce s editorem


Práce s editorem

Vytvoření nové scény
Nasvětlování scény a mlha
Používání objektové databáze
Typy objektu BES
Typy speciálních objektů
Finalizace scény


Inicializační soubory scény

Pro nastavení některých informací pro scénu se používají dva inicializační soubory. Tyto soubory nejsou nutné pro správné fungování jak grafické, tak herní časti scény.

Bitmapa Level.tga

cesta : \[adresář hry]\levels\[adresář mapy]\data\[sub-level adresář]\level.tga

Tuto bitmapu je nutné vytvořit v editoru pomocí nástroje Level bitmap view.

menu : editor \ level bitmap view

Po spuštění tohoto nástroje se scéna zobrazí v pohledu z vrchu. Kurzorovými klávesami je možné scénou posouvat a klávesami + a - přibližovat nebo vzdalovat. Po optimálním nastavení scény ve výhledu je možné uložit bitmapu. Tato se uloží ve formátu bmp.
Pro správné nastavení je důležité si uvědomit, jestli chcete touto bitmapou ovliňovat pouze část scény nebo celou. Podle toho je pak nutné si správně nastavit pohled před jejím vyexportováním.
Návrat do editoru je možný po vytvoření level.bmp opět přes - menu \ editor \ level bitmap view.

menu | : | editor \ save level.bmp
klávesa | : | f1

Po vyexportování bitmapy je nutné uložit scénu!

Tuto texturu je nutné upravit v některé kreslícím programu, který podporuje formát tga. Editor využívá jednotlivé barevné kanály. Každý samostatný kanál má svou funkci.

Na vyexportované bitmapě je jeden bod s RGB 255, 255, 255, který určuje absolutní nulu scény. Tento bod je nutné zachovat i v hotové bitmapě level.tga! Bitmapu je možné ořezávat, popřípadě nastavovat. Není možné ji však měnit měřítko!

Příklad bitmapy Level.tga:

Funkce barevných složek bitmapy Level.tga
zelená | určuje procentuelní změnu dohlednosti a mlhy, hodnota g=100 je rovna 100% nastavení dohlednosti v editoru, hodnoty nižší snižují a vyšší zvětšují dohled, maximální hodnota je 254
modrá | určuje index prostoru pro déšť

Inicializační soubor Level.ini

cesta : \[adresář hry]\levels\[adresář mapy]\data\[sub-level adresář]\level.ini

V tomto souboru je možné nastavit některé vlastnosti scény.

RAIN_visibility= dist
dist vzdálenost v metrech
základní hodnota = 10
doporučené rozmezí = 5 až 15
mise bez dešte = 0

RAIN_density= val
val rozestup mezi kapkama
základní hodnota = 1
doporučené rozmezí = 1 až 5

RAIN_area= area_id, appear_up, around_tolerance, wind_x, wind_y, wind_rnd, speed, intensity, drop_len, drop_width, color_r, color_g, color_b, color_a
area_id | intenzita modré složky bitmapy level.tga doporučené rozmezí = 0 až 254
appear_up | hodnota určující, jak vysoko nad camerou se kapky objevují světlá obloha = cca 6 tmavá obloha = cca 10
around_tolerance | tolerance odchylky kapky
wind_x, wind_y | směr větru v ose x a y doporučené rozmezí = -0.08 až 0.08
wind_rnd | náhodnost větru pro jednotlivé kapky doporučené rozmezí = 0 až 0.1
speed | rychlost letu kapky základní hodnota = 20
intensity | hustota deště počet kapek za vteřinu na plochu RAIN_density čtverečný
drop_len | délka kapky základní hodnota = 1 doporučené rozmezí = 0.5 až 1
drop_width | šířka kapky základní hodnota = 0.01
color_r, color_g, color_b | barva kapky základní hodnota = 190, 190, 190
color_a | průhlednost kapky základní hodnota = 100

VIS_use= val
val přepínač používání zelené složky bitmapy level.tga pro viditelnost
0 = nepoužívat
1 = používat

VIS_ext= back, zmin, zmax
back | přepínač používání zelené složky bitmapy level.tga pro viditelnost pozadí 0 = nepoužívat 1 = používat
zmin | spodní hranice používání mapy 0 = používat do záporného nekonečna
zmax | horní hranice používání mapy 0 = používat do kladného nekonečna

WATER_fog= material_name, fog_r, fog_g, fog_b, fog_start, fog_end, backgrnd_fog_start, backgrnd_fog_end, max_water_depth
material_name | jméno kolizního materiálu, např. HB pro hladinu bahna
fog_r, fog_g, fog_b | barva mlhy
fog_start | vzdálenost na které mlha začíná
fog_end | vzdálenost na které mlha končí
backgrnd_fog_start | vzdálenost na které začíná mlha pozadí
backgrnd_fog_end | vzdálenost na které končí mlha pozadí
max_water_depth | maximální hloubka vody

WATER_sound= material_name, sound
material_name | jméno kolizního materiálu, např. HB pro hladinu bahna
sound | ID zvuku 2205 = stojatá voda 2236 = tekoucí voda

PL_noshoot_light= val
val přepínač nasvětlování objektů od zbraní
základní hodnota = 0
0 = nasvětlovat
1 = nenasvětlovat

PL_shad= type, alpha
type | typ stínu pod hráčem základní hodnota = 2 0 = žádný 1 = kruhový 2 = promítaný
alpha | průhlednost stínu možné rozmezí = 0 až 1


Nasvětlování scény a mlha

Nasvětlení scény

Scénu lze nasvětlovat dvěma způsoby.

1. Každý sektor ve scéně obsahuje nastavení ambientního, směrového světla a mlhy

2. Další možností je použití objektů bodového a kuželového světla.

Světový sektor (World sector) je v každé nově založené scéně.

Nasvětlení pozadí

Nasvětlení pozadí se nastavuje ve vlastnostech sektoru Background, který je možno vybrat v Select okně (klávesa Home).

Sektor Backgroud je v každé nově založené scéně.

Základní vlastnosti v záložce Properties

Color kliknutím na barvu se otevře dialog pro výběr barvy
Pipetu lze vyvolat pomocí klávesy Shift a pravého tlačítka myši na barvě

Color | kliknutím na barvu se otevře dialog pro výběr barvy Pipetu lze vyvolat pomocí klávesy Shift a pravého tlačítka myši na barvě
Near | vzdálenost od které se aplikuje mlha
Far | vzdálenost do které se aplikuje mlha
On | přepínač používání mlhy

Light
Subentita - Sector


Vytvoření FPV mapy

cesta : \[adresář hry]\levels\[adresář mapy]\data\[sub-level adresář]\mapfpv\map.dds

FPV mapa se zoprazuje ve hře klávesou M.

Tuto bitmapu je nutné vytvořit v editoru pomocí nástroje Level map view.

menu : menu \ level map view

Po spuštění tohoto nástroje se scéna zobrazí v pohledu z vrchu, překrytá modrou plochou, ohraničující budoucí mapu. Podle této plochy je nutné si správně nastavit pohled před jejím vyexportováním.

Kurzorovými klávesami je možné scénou posouvat a klávesami + a - přibližovat nebo vzdalovat. Po optimálním nastavení scény ve výhledu je možné uložit klávesou Spacebar bitmapu. Tato se uloží ve formátu bmp.

klávesa : spacebar

Návrat do editoru je možný po vytvoření map.bmp opět přes - menu \ editor \ level map view.

Tuto texturu je nutné upravit v některé kreslícím programu.
Finální textura musí být ve formátu DDS a jej9 rozměr musí odpovídat platným rozměrům pro DirectX.

Příklad bitmapy map.bmp:

Příklad bitmapy map.dds:

Funkce Contour lines

menu : menu \ countour lines (on/off)

Po spuštění tohoto nástroje se zobrazí dialog s nastavením výškového rozestupu vrstevnic pro vybrané objekty.

distance výškový rozestup vrstevnic pro vybrané objekty v metrech

Nástroj je možné vypnout opět v: menu \ editor \ countour lines (on/off)

Typy a podmínky používaných bitmap


Vytvoření nové scény

panel | : file / new scene
klávesa | : ctrl + n

Před vytvořením nové scény je nutné založit na pevném disku adresář scény, a to v:

\[adresář hry]\levels\

a uložit do něj soubory *.bes pro terén a pro nebe.

Jméno scény nesmí obsahovat mezery!

Také je možné uložit do ní potřebné textury ve formátu *.bmp, *.tga nebo *.dds, a to do vnořeného adresáře Tex. Pro finalizaci scény by všechny textury měly být uloženy ve formátu dds. Vyjímkou jsou textury pro nebe, které je možno ponechat ve formatu bmp.
Datové soubory používané scripty (objekty, zvuky, ...) je nutné uložit do adresaře ForScripts v sub-level adresáři.

Takto připravená data by na pevném disku měla mít přibližně tuto podobu:

Další soubory s modely je možné uložit do vnořeného adresáře Objects.

Pokud jsou všechna potřebná data připravena je možno přes menu nebo klávesou spustit New Scene Wizard.

Zde si vyberete vámi vytvořený adresář se scénou a zadáte jméno pro mapu. Jméno datového adresáře bude automaticky vytvořeno z jména mapy. Toto jméno je možné podle potřeby změnit v záložce Scene v Editor panelu.
V dalším okně je nutné vybrat ze seznamu soubory s objekty terénu a nebe mapy.

S takto vytvořenou scénou je již možné dále pracovat.
Výsledná adresářová struktura pro finalizaci scény může vypadat například takto:

Konvence jmen souborů

soubor terénu scény | \[adresář hry]\levels\[adresář mapy]\terrain_[jméno].bes
soubor nebe scény | \[adresář hry]\levels\[adresář mapy]\sky_[jméno].bes
inicializační soubor scény | \[adresář hry]\levels\[adresář mapy]\data\[sub-level adresář]\level.ini
datová bitmapa scény | \[adresář hry]\levels\[adresář mapy]\data\[sub-level adresář]\level.tga
náhled scény | \[adresář hry]\levels\[adresář mapy]\data\[sub-level adresář]\thumb.bmp
hlavní script scény | \[adresář hry]\levels\[adresář mapy]\data\[sub-level adresář]\scripts\level.c

Konvence umístění souborů scény

základní soubory scény | \[adresář hry]\levels\[adresář mapy]
adresář pro ostatní soubory modelů | \[adresář hry]\levels\[adresář mapy]\objects
adresář všech textur scény | \[adresář hry]\levels\[adresář mapy]\tex
datový adresář scény | \[adresář hry]\levels\[adresář mapy]\data\[sub-level adresář]
adresář grow objektů | \[adresář hry]\levels\[adresář mapy]\data\[sub-level adresář]\grow
adresář scriptů scény | \[adresář hry]\levels\[adresář mapy]\data\[sub-level adresář]\scripts
adresář dat použitých ve scriptech | \[adresář hry]\levels\[adresář mapy]\data\[sub-level adresář]\forscripts
adresář světelných map scény | \[adresář hry]\levels\[adresář mapy]\data\[sub-level adresář]\ldt

Inicializační soubor scény
Používání objektové databáze
Typy speciálních objektů


Finalizace scény

menu : file / finalize mp mission

Tato funkce provede všechny potřebné úkony pro finalizaci scény. Před jejím puštěním je nutno vypnit alespoň jeden typ MP hry.
Pokud kontrola nenalezne soubory level.c a sound.c v adresáři:
\levels\[adresář mapy]\data\[sub-level adresář]\scripts\,
použijí se základní scripty.

Data takto vytvořené scény jsou složena ze dvou souborů:

[jméno scény].cbf
[jméno scény].dat

Adresář, kde Vietcong hledá tyto soubory, je: \maps\

Oba soubory je nutné mít uložené v tomto adresáři.

Takto připravená data pro síťovou hru je možné testovat s více hráči, kteří mají také tuto verzi editoru.
Hra se spouští přes:

menu : game / game menu

Pokud budete zakládat server, Vaše scéna by se měla objevit v seznamu.

Definice MP her
Vytvoření náhledu pro mapu


Definice MP her

menu : editor / multiplayer game editor

MP game editor

Tento editor slouží k nastavení jména hry a jejích typů. Bez vyplněných informací v tomto dialogu není možné vytvořit finální zabalenou MP hru.

Game name | jméno, které se zobrazuje v seznamu MP her
Game types | typy her, které je možno v této scéně hrát
Modify | otevře dialog pro upravu zvoleného typu hry
Delete | smaže ze seznamu zvolený typ hry
New | otevře dialog pro vytvoření nového typu hry
Preview | automaticky vytvořený náhled

MP game type editor

Tento editor slouží k vytvoření nebo editaci typů her.

Game type name | jméno typu hry
Game type description | celkový popis typu hry
Game type US description | popis typu hry na US straně
Game type VC description | popis typu hry na VC straně
Maximum num. players | maximální počet hráčů
Script type | výběr scriptu podle typu hry
Script file | umístění souboru scriptu
Time | ...
Points | ...
Frags | ...

Typy podporovaných MP her


Vytvoření náhledu pro mapu

cesta : \[adresář hry]\levels\[adresář mapy]\data\[sub-level adresář]\thumb.bmp

Náhled se zobrazuje při výběru mapy v Game menu.

Bitmapa musí být uložena ve formátu BMP a její rozměr musí být 290x189 bodů.

Příklad bitmapy thumb.bmp:


Typ objektu BES

panel : database / current level ( [image])
panel : database / package ( [image])

Objekt BES je vytvořený a vyexportovaný ze 3ds max. Obsahuje grafická data modelu.

Výběr objektu BES je možné pouze pokud je vypnutý přepínač Entity/Subentity [image], klávesa Q.

Základní vlastnosti v záložce Properties

Entity name jméno objektu zobrazované v editoru

Clip Distance | vzdálenost v metrech, po které se objekt přestane vykreslovat
Current | nastaví aktuální vzdálenost kamery od středu objektu

Is Background | přepínač umístění objektu ve scéně nebo na pozadí, ikona:
Bilboard XZ | objekt se bude natáčet za kamerou v osách X a Z, ikona:
Bilboard Z | objekt se bude natáčet za kamerou v ose Z, ikona:
No cut by visibility | objekt se bude zobrazovat i za maximální viditelností nastavenou v záložce scene

Set/Add | zobrazí dialog pro asociaci sektorů
Remove | zruší asociaci vybraných sektorů v seznamu

Používání objektové databáze
Subentita
Subentita - Ocluder
Subentita - Portal
Subentita - Sector


Subentita

ikona :

Objekty Subentita jsou jednotlivé části souboru BES.

Výběr objektu subentita je možné pouze pokud je zapnutý přepínač Entity/Subentity [image], klávesa Q.

Základní vlastnosti v záložce Properties

Clip Distance | vzdálenost v metrech, po které se objekt přestane vykreslovat.
Current | nastaví aktuální vzdálenost kamery od středu objektu.

Dirlight multiplier | násobitel nasvícení směrovým světlem
Ambient multiplier | násobitel nasvícení rozptýleným světlem
Apply SHM shadow | aplikovat data stínového stromu na objekt
Compute LM | počítat světelné mapy na objekt
LM density | detailnost světelných map pro jednotlivé LOD objekty, číslo určuje počet mnohoúhelníků na jednu texturu
No smooth | vypočítaným světelným mapám nevyhlazovat textury
Cast shadow | objekt vrhá stíny
Intensity | intenzita vrženého stínu
Cast SHM shadow | objekt je započítán do výpočtu stínového stromu
For LM comp only | objekt je ve scéně pouze pro výpočet světelných map, při přepnutí do hry se neobrazuje
Dynamic object | přepínač mezi typem statický a dynamický objekt

Object occludding design tvar pro výpočet schování objektu mimo portál nebo za ocluderem

Tvar Particled je tvořen obdélníkem, který se otáčí vždy za kamerou a vždy zakrývá celý objekt.

Tvar Boxed je tvořen krychlí podle maximálních rozměrů objektu. Výpočet tohoto tvaru je přesnější, ale i pomalejší.

Set/Add | zobrazí dialog pro asociaci sektorů
Remove | zruší asociaci vybraných sektorů v seznamu

Seznam | seznam vzdáleností přepnutí jednotlivých LOD objektů, vzdálenost je možné měnit po dvojitém kliknutí levého tlačítka myši (LMB) na vzdálenost
Show selected LOD | přepínač zobrazení vybraného LOD objektu - pouze pro editaci
Last LOD alpha | přepínač mizení posledního LOD objektu pomocí průhlednosti

Dist | vzdálenost pro přepnutí LOD objektu, pro zadání nemizení posledního LOD objektu zapište -1
Set current | nastaví aktuální vzdálenost kamery od středu objektu.

BES


Subentita - Ocluder

ikona :

Ocluder je zastiňovací objekt pro portály a rendrovací objekty. Je možno jej použít uvnitř sektoru například do zdí.

Tento objekt nemá žádné editovatelné vlastnosti.

BES
Subentita - Portal
Subentita - Sector


Subentita - Portal

ikona :

Portál slouží průchodu mezi sektory a nastavování zobrazování objektů k nim asociovaných.

Každý portál musí mít svého dvojníka. Pokud portál ústí do světového sektoru, jeho dvojník se automaticky vytvoří.

Základní vlastnosti v záložce Properties

Closing dist. | vzdálenost portálu od kamery ve které se zavře
Current | nastaví aktuální vzdálenost kamery od středu objektu
Items visibility | vzdálenost portálu od kamery od které se vykreslují pouze objekty přilinkované k sektoru ve 3ds Max
Current | nastaví aktuální vzdálenost kamery od středu objektu
Fading dist. | vzdálenost portálu od kamery ve které se portál začne obarvovat
Current | nastaví aktuální vzdálenost kamery od středu objektu
Portal color | přepínač používání obarvování portálu
R, G, B | barevné složky zabarvení portálu, kliknutím na barvu se otevře dialog pro výběr barvy Pipetu lze vyvolat pomocí klávesy Shift a pravého tlačítka myši na barvě
Copy doubler's props | nastaví hodnoty podle dvojníka portálu

Portal | jméno dvojníka
Change to | přepne výběr na dvojníka
Select into | vybere oba portály

BES
Subentita - Ocluder
Subentita - Sector


Subetntita - Sector

Subentita - Sector

menu | : | edit \ select \ current sector
klávesa | : | e
ikona | : |

Sektor je vymezený prostor ohraničující část scény. Jeho existence je podmíněna optimalizací scény.

Průchod mezi sektory je umožněn Portály, které také nastavují, které objekty asociované k sektorům se mají vykreslovat.

Aktuální sektor, ve kterém se nachází kamera je možné vybrat klávesou E. Informace o aktuálním sektoru se vypisují na pravé straně status řádky.

Každá scéna obsahuje World sector a Backgroud, což jsou její základní sektory.

Základní vlastnosti v záložce Properties

Color | kliknutím na barvu se otevře dialog pro výběr barvy Pipetu lze vyvolat pomocí klávesy Shift a pravého tlačítka myši na barvě
On | přepínač používání ambientního světla

Color | kliknutím na barvu se otevře dialog pro výběr barvy Pipetu lze vyvolat pomocí klávesy Shift a pravého tlačítka myši na barvě
Direction | směr světla v radiánech
From camera | nastaví směr světla podle pohledu kamery
Invert | obrátí směr světla
On | přepínač používání směrového světla

Color | kliknutím na barvu se otevře dialog pro výběr barvy Pipetu lze vyvolat pomocí klávesy Shift a pravého tlačítka myši na barvě
Near | vzdálenost od které se aplikuje mlha
Far | vzdálenost do které se aplikuje mlha
On | přepínač používání mlhy

BES
Subentita - Ocluder
Subentita - Portal


Typy speciálních objektů

menu : entities / create
panel : database / special objects

Speciální objekty jsou objekty používané pro finalizaci scén. Tyto objekty jsou součástí editoru a mají specifické vlastnosti.

Editor používá tyto typy:
Dummy pomocný objekt, který se používá pro optimalizace scén, scripty, ...
Event objekt pro grafické a zvukové efekty
Fauna objekt pro vkládání žívočichů do scény
Level item používá se pro vkládání modelů do scény, které může hráč zvednout - jako například zbraně
Light bodové a kuželové světlo
MP Helper pomocný objekt pro MP hru, pomocí kterého je možno do scény přidávat vlajky, bedny na zbraně, ...
North star pomocný objekt pro nastavování světových stran ve scéně a pro mapu scény
Player pomocný objekt pro vkládání scriptovaných postav do SP a MP kooperativní hry
Recovery point místa, kde se objevují hráči v MP hře
Script helper pomocný objekt spolupracující se scripty
Sound switch pomocný objekt zvukového systému pro místa změny zvukových nastavení - například EAX
Spectator camera kamera pro vnějšího pozorovatele MP hry
Way point pomocný objekt pro vytyčení cest AI v SP a MP kooperativní hře

Poznámka:
SP - hra pro jednoho háče (single player)
MP - hra pro více hráčů, např. přes internet (multiplayer)

Používání objektové databáze


Speciální objekt - Dummy

menu : entities / create / dummy
panel : database / special objects / dummy ( [image])

Dummy je pomocný objekt, který se používá pro optimalizace scén, scripty, a jiné.

Přilinkováním objektů k dummy v jeho okolí se urychlí prohledávání stromu objektů a tím i samotná hra. Dále je možno nastavit tomuto dummy clip distance (vzdálenost, ve které se dummy a jeho děti nevykreslují).

Editor podporuje vytvoření objektu Hierarchy dummy. Jedná se o objekt dummy vytvořený ve středu bounding boxu všech vybraných objektů, které se pak na něj automaticky přilinkují. V editor panelu se přepne záložka na Properties, aby bylo možné vyplnit clip distance.

Vytvořit Hierarchy dummy lze klávesou INSERT.

Příklad:

Podle tohoto příkladu se všechny objekty přilinkované k Hierarchy dummy přestanou zobrazovat, pokud vzdálenost kamery od středu dummy bude větší než 50m.

Základní vlastnosti v záložce Properties

Entity name jméno objektu zobrazované v editoru

Clip Distance | vzdálenost v metrech, po které se objekt přestane vykreslovat.
Current | nastaví aktuální vzdálenost kamery od středu objektu.

Typy speciálních objektů
Používání objektové databáze


Speciální objekt - Event

menu : entities / create / event
panel : database / special objects / event ( [image])

Event je objekt na vytváření zvukových a grafických efektů. Každý event může pouštět pouze jeden druh efektu, buď zvukový nebo grafický.

Základní vlastnosti v záložce Properties

Entity name jméno objektu zobrazované v editoru

Clip Distance | vzdálenost v metrech, po které se objekt přestane vykreslovat.
Current | nastaví aktuální vzdálenost kamery od středu objektu.

Do řádku vedle typu se vyplňuje ID efektu.
V současné době není podporován typ Flare.
Sound: Select otevře dialog výběru grafických efektů.

Seznam Sound groups obsahuje skupiny zvuků a Sounds jednotlivé zvuky ve vybrané skupině.

Sound: Effect otevře dialog výběru grafických efektů.

Důležítý je výběr efektu. Seznam sub-efektů je pouze informativní.

Nastavení časování pro efekt je možné zvolit:
Signal | efekt je pouštěn pouze se scriptu
Effect interval | základní nastavení efektu
Defined | uživatelské nastavení časování

Typy speciálních objektů
Používání objektové databáze


Speciální objekt - Event

Speciální objekt - Fauna

menu : entities / create / fauna
panel : database / special objects / fauna ( [image])

Objekt Fauna umožňuje vkládat do scény různý hmyz a drobné zvířata. Jeden objekt Fauna může obsahovat různé druhy hmyzu i zvěře.
Všechny typy, mimo Hmyz, reagují na pohyb hráče a AI.
Speciální případ je typ Ptáci. Tento typ se inicializuje až ve chvíli, kdy je způsoben poplach.

Podporované typy fauna
Hmyz | Butterfly (motýl), Dragonfly (vážka), Wasp (vosa), Fly (mucha)
Drůbež | Duck (kachna), Hen (slepice)
Malí živočichové | Frog (žába), Rat (krysa)
Velcí živočichové | Buffalo (buvol)
Ptáci | Parrot (papušek), Dove (holub)

Základní vlastnosti v záložce Properties

Entity name jméno objektu zobrazované v editoru

Clip Distance | vzdálenost v metrech, po které se objekt přestane vykreslovat.
Current | nastaví aktuální vzdálenost kamery od středu objektu.

Add | zobrazí dialog na výběr typů hmyzu a zvěře.
Remove | vyjmutí vybraného typu Fauny
Create radius | vzdálenost v metrech, ve které se od středu objektu Fauna vytvoří a pohybuje hmyz a zvěř
Count | počet vytvořených modelů hmyzu a zvěře
Upper hemi. only | hmyz se pohybuje pouze v horní polovině koule vzniklé kolem objektu Fauna
Do not collide | hmyz pro výpočet pohybu nepoužívá kolizní strom
Max flying height | maximální výška pro pohyb hmyzu
AI makes alert | umělá inteligence (AI) způsobuje poplach zvěře
Step over radius | maximální vzdálenost od objektu Fauna, do které se může zvěř pohybovat, pokud je v módu poplach
Predator radius | vzdálenost, ve které hráč, popřípadě AI, způsobí poplach
Shot radius | vzdálenost, do které střelba hráče, popřípadě AI, způsobí poplach
Respawn time | čas, po kterém je možné opět způsobit poplach u typu Ptáci

Typy speciálních objektů
Používání objektové databáze


Speciální objekt - Level item

menu : entities / create / level item
panel : database / special objects / level item ( [image])

Objekt Level item umožňuje umístit do scény modely, které jsou interaktivní s hráčem. Jsou to objekty, které může hráč vzít do ruky, popř. použít.

Standartně se zobrazuje pouze ikona objektu. Zapnout zobrazování vybraného modelu můžete zde:

menu: view / draw / level item beses

Základní vlastnosti v záložce Properties

Entity name jméno objektu zobrazované v editoru

Clip Distance | vzdálenost v metrech, po které se objekt přestane vykreslovat.
Current | nastaví aktuální vzdálenost kamery od středu objektu.

Weapons | zbraně, které může hráč ve hře vzít do ruky a použít
Ammo | zásobníky do zbraní, které může hráč ve hře vzít do ruky a použít
Intel | speciální objekty, které může hráč vzít do ruky a prohlédnout si je

Typy speciálních objektů
Používání objektové databáze


Speciální objekt - Light

menu : entities / create / light
panel : database / special objects / light ( [image])

Light je objekt, který simuluje reálné světlo. Editor používá dva typy světel - Omni a Spot.
Každé takovéto světlo vložené do scény je statické. To znamená, že všechny jeho hodnoty a transformace při přepnutí do hry jsou neměnné.
Jedno z omezení při používání světel je jejich maximální počet pro osvětlení jednoho objektu. Tento počet je osm a započítávají se do něj i světla dynamická a světelné nastavení sektorů.

Omni vrhá z jednoho bodového zdroje světlo ve všech směrech.

Světlo Spot má kuželový směr paprsků.

Základní vlastnosti v záložce Properties

Entity name jméno objektu zobrazované v editoru

Clip Distance | vzdálenost v metrech, po které se objekt přestane vykreslovat.
Current | nastaví aktuální vzdálenost kamery od středu objektu.

Disable light | přepínač zapnutí/vypnutí používání světla
Light color | kliknutím na barvu se otevře dialog pro výběr barvy Pipetu lze vyvolat pomocí klávesy Shift a pravého tlačítka myši na barvě

Radius | dosvit paprsků
Const. attenuation | konstatní násobitel světla
Linear attenuation | násobitel, jehož hodnota se se vzdáleností blíží nule
Oba násobitelé se sčítají.

Inner angle | vnitřní úhel rozevření světelného kužele, ve kterém má světlo stejnou intenzitu do stran
Outer angle | vnější úhel rozevření světelného kužele, do kterého se světlo do stran utlumuje

Shadows | přepínač počítání stínů podle světla
Realtime shadows | zatím není podporováno
SHM shadows | přepínač počítání stínového stromu pro hráče a dynamické objekty
Use sector affiliation | přepínač pro používání asiciace světla k sektorům pokud světlo není k žádnému sektoru asociováno nebo je přepínač vypnutý, svítí ve všech sektorech

Set/Add | zobrazí dialog pro asociaci sektorů
Remove | zruší asociaci vybraných sektorů v seznamu

Informace o použití statických světel
Nasvětlování scény
Používání objektové databáze
Typy speciálních objektů


Speciální objekt - MP helper

menu : entities / create / mp helper
panel : database / special objects / mp helper ( [image])

MP helper objekt, který se používá pro umisťování herních prvků pro síťovou hru.

Základní vlastnosti v záložce Properties

Entity name jméno objektu zobrazované v editoru

Clip Distance | vzdálenost v metrech, po které se objekt přestane vykreslovat.
Current | nastaví aktuální vzdálenost kamery od středu objektu.

Mode | typ MP hry
Item | herní prvky jednotlivých her

Seznam herních prvků
 | ATG Bombing - je nutné použít všechny prvky
bombplace | místo, kde se musí položit bomba
c4 | objekt, který je nutné umístit na místo, kde se bude pokládat bomba
 | ATG Pilot
Landing zone | místo, kam se musí dostat hráč pilot
 | CTF
Ammo box | místo, kde se mohou brát zásobníky
Flag US | místo, které musí obsadit VC vojáci
Flag VC | místo, které musí obsadit US vojáci
 | DM
Bedna 1 | místo, na které se pokládají zbraně při editaci MP hry
Bedna 2 | místo, na které se pokládají zbraně při editaci MP hry
 | RW
Ammo box | místo, kde se mohou brát zásobníky
Flag villageA, ..., Flag villageF | místo, které musí hráči obsadit
 | TT
Flag 1, ..., Flag 5 | místo, kde se hráč objevuje, pokud je obsadí
Flag final | místo, které musí hráči obsadit

Typy podporovaných MP her
Typy speciálních objektů
Používání objektové databáze


Speciální objekt - North star

menu : entities / create / north star
panel : database / special objects / north star ( [image])

Pomocný objekt pro nastavování světových stran ve scéně a pro mapu scény. Tento objekt nemá žádné mněnitelné vlastnosti.

Typy speciálních objektů
Používání objektové databáze


Speciální objekt - Player

menu : entities / create / player
panel : database / special objects / player ( [image])

Player se používá pro umisťování hráčů do scén v SP a MP kooperativní hře.

Konvence umístění souborů scriptů pro hráče

Umístění scriptů pro hráče SP hry:

\levels\[adresář mapy]\data\[sub-level adresář]\scripts

Umístění scriptů pro hráče MP kooperativní hry:

\levels\[adresář mapy]\data\[sub-level adresář]\scripts\coop

Základní vlastnosti v záložce Properties

Entity name jméno objektu zobrazované v editoru

Script | zobrazí dialog pro vyhledání scriptu hráče
Set default script | nastaví základní script hráče

Speciální objekt - Recovery point
Typy speciálních objektů
Používání objektové databáze


Speciální objekt - Recovery point

menu : entities / create / recovery point
panel : database / special objects / recovery point ( [image])

Recovery point se používá pro umisťování hráčů do MP map. Je to místo, kde se objevují hráči na začátku hry nebo po uplynutí nastaveného času hry. Maximální počet Recover point objektů jednoho modu je 64. Vyjímkou je US ATG Pilot, který může být umístěn v mapě pouze jednou, a US Coop, kterých může být maximálně šest.

Barva ikony se mění v závislosti na modu hry, pro kterou je recovery point nastaven.

Základní mody Recovery point objektu
 | ATG
US ATG | místo, kde se objevují US vojáci
US ATG Pilot | místo, kde se objevuje US pilot tento mod může být použitý v jedné mapě pouze jednou
VC ATG | místo, kde se objevují VC vojáci
 | CooP
US Coop | místo, kde se objevují US vojáci těchto typů může být použito v jedné mapě pouze šest
 | CTF
US Flag | místo, kde se objevují US vojáci
VC Flag | místo, kde se objevují VC vojáci
 | DM, LMS, TDM
DM | objevovací místo pro hráče
 | RW
US RW | místo, kde se objevují US vojáci
VC RW | místo, kde se objevují VC vojáci
WA - WF | místa, kde se objevují vojáci týmu, který obsadil odpojídající vlajku

Základní vlastnosti v záložce Properties

Entity name jméno objektu zobrazované v editoru

Mode | typy objevování hráčů podle modu hry
Number of rec. points | součet všech Recovery point objektů stejného typu jako je vybraný maximální počet
Select | vybere všechny Recovery point objekty stejného typu jako je aktuální vybraný z celé scény

Typy podporovaných MP her
Typy speciálních objektů
Používání objektové databáze


Speciální objekt - Sound switch

menu : entities / create / sound switch
panel : database / special objects / sound switch ( [image])

Sound switch slouží k přepínání zvukových parametrů průchodem kamery. Lze měnit typ zvuků chůze a dopadajících dynamických objektů a nastavení EAX. Sound switch je orientovaná koule, kladná polovina je označena šipkou.

Základní vlastnosti v záložce Properties

Entity name jméno objektu zobrazované v editoru

Env1 | otevře dialog pro výběr environmentálních presetů pro kladnou část objektu
Env2 | otevře dialog pro výběr environmentálních presetů pro zápornou část objektu, nebo pro středovou rovinu koule
Eax rad. | poloměr koule pro postupnou změnu parametrů EAX
Entire sphere interpolation | přepínač používání celé koule nebo kladné polokoule od středové roviny pro změnu parametrů EAX

Create new | vytvoření nového presetu
Delete | smazání vybraného presetu
Name | jméno presetu
EAX id | číslo předdefinovaného typu EAX
Env. sound volume | nastavení hlasitosti presetu

EAX - nastavení prostorových vlastností zvuku

Typy speciálních objektů
Používání objektové databáze
Předdefinované typy EAX


Speciální objekt - Spectator camera

menu : entities / create / spectator camera
panel : database / special objects / spectator camera ( [image])

Tento objekt definuje místo, ze kterého může pozorovatel sledovat MP hru.

Základní vlastnosti v záložce Properties

Entity name jméno objektu zobrazované v editoru

Mode typ MP hry

Text ID: číslo textu
pokud je číslo rovné 0, jako text se bere Entity name

Seznam čísel textů
 | ATG
5086 | bombplace
5087 | landing zone
5088 | central
 | CTF
5073 | vc side
5074 | us side
 | RW
5075 | flag 1
5076 | flag 2
 | TT
5089 | camera 1
5090 | camera 2

Typy podporovaných MP her
Typy speciálních objektů
Používání objektové databáze


Speciální objekt - Way point

menu : entities / create / way point
panel : database / special objects / way point ( [image])
panel : place / !waypoint

Way point je pomocný objekt pro AI (umělou inteligenci). Těmito objekty je nutné v SP a MP coopertivní hře vyznačit průchody pro AI.

Vkládat way pointy do scény je možné jak z databáze, tak pomocí funkce Placeator (klávesa O).

Jednotlivé way pointy je nutné spojovat. Na toto se používá funkce Link at (klávesa P). Pokud chcete vytvořit pouze jednosměrné propojení way pointů, klávesou Shift a linkováním rušíte nebo přidáváte jednosměrné propojení.

Maximální počet way pointů na scénu je 2500.

V tomto obrázku jsou horní dva way pointy spojeny jednosměrně ve směru hodinových ručiček (CW) a spodní dva obousměrně s prostředním way pointem.
Zadní dva jsou nastveny jako No shortcuts a prostřední jako HideOut.

Základní vlastnosti v záložce Properties

Entity name jméno objektu zobrazované v editoru

No shortcuts | přes tento way point musí AI projít
HideOut | na tomto míste se může AI schovat

Typy speciálních objektů
Placeator
Používání objektové databáze


Asociace k sektorům - Associate

toolbar | : associate
klávesa | : a

Funkce Associate umožňuje přiřazovat vybrané objekty sektorům.
Po aktivaci této funkce je možné vybraným objektům, kliknutím levým tlačítkem myši (LMB) kamkoliv do sektoru, tento sektor přiřadit.

Toto přiřazení lze také provést v Editor panelu v záložce Properties.

Výběr objektů ve scéně


Kopírování - Duplicate

toolbar | : duplicate selected
klávesa | : d

Funkce Duplicate umožňuje kopírovat vybrané objekty ve scéně.
Rychlá funkce se aktivuje pomocí držení prostředního tlačítka myši (MMB).

Po její aktivaci je možné vybrané objekty kopírovat pohybem myši v osách x, y a z. Standartně povolený pohyb je pouze v ose x a y. Pro změnu os nebo omezení pohybu jen v některých osách lze použít tyto klávesy:
Shift | osa X
Ctrl | osa Y
Shift + Ctrl | osa Z

Výběr objektů ve scéně


Linkování

Linkování

toolbar | : link at
klávesa | : p

Funkce Link at umožňuje vytváření stromů objektů, který je možno použít např. pro optimalizace scén.
Po aktivaci této funkce je možné vybrané objekty nalinkovat na jiné. Takto vzniklý objekt se jmenuje child a objekt na který je přilinkován parent.

Každý child objekt může mít pouze jeden objekt parent. To znamená, že pokud budete chtít jeden objekt přilinkovat na více parentů, bude výsledná vazba na posledního.

Odlinkování

toolbar : unlink

Funkce Unlink ruší vazbu child -> parent.

Výběr objektů ve scéně


Pohyb kamery v editoru

Pohyb kamery

Pohyb kamery ve scéně se ovládá kurzorovými klávesami.

Rychlost pohybu kamery ve scéně se nastavuje klávesami + a - na číselné klávesnici.

Rotace kamery

Při držení pravého tlačítka myši (RMB) se aktivuje funkce rotace kamery. Pohybem myši se pak kamera otáčí kolem své osy.

Rotace kamery - orbit

Při držení klávesy Alt a pravého tlačítka myši (RMB) se aktivuje funkce orbit. Po aktivaci této funkce se najde v průsečíku kamery a středu okna objekt nebo bod, podle kterého se pak kamera při pohybu myší otáčí.


Pokládání objektů - Parachute

toolbar | : parachute
klávesa | : t

Funkce Parachute umožňuje umisťovat vybrané objekty na jiné.
Tyto objekty kolidují z maximální výšky scény s objekty v ní.

Landing selection group | výběr pojmenované skupiny objektů, pokud zůstane none, výpočet bude prováděn proti všem objektům ve scéně
Sink in | posunutí položeného objektu v ose Z

Skupiny výběrů
Výběr objektů ve scéně


Pokládání objektů - Placeator

toolbar | : placeator
klávesa | : o

Funkce Placeator umožňuje umisťovat nové objekty do scény.
Po aktivaci této funkce se přepne záložka v Editor panelu do Place. Po nastavení parametrů je možné levým tlačítkem myši pokládat objekty na objekty ve scéně.

Záložka Place


Pravítko

toolbar | : ruler
panel | : help / ruler

Tímto nástrojem lze měřit vzdálenosti ve scéně. Po kliknutí pravým tlačítkem myši je možné pravítko položit a dalším pohybem po scéně měřít delší vzdálenosti. Tyto součty se zapisují v editor panelu v záložce Help.

Draw pin all the time | umožňuje mít zapnutý objekt pravítka i po přepnutí do hry
Dx, Dy, Dz | vzdálenost v jednotlivých osách od místa posledního položení pravítka
X, Y, Z | pozice pravítka ve scéně
SumDistance | součet všech naměřených vzdáleností
Clear SumDistance | nuluje celkový součet naměřených vzdáleností


Transformační funkce

Posun objektu - move

menu | : edit / transform / move
toolbar | : move selected
klávesa | : M

Funkce Move se po přepnutí do ní aktivuje držením levého tlačítka myši (LMB).

Po její aktivaci je možné vybrané objekty posouvat pohybem myši v osách x, y a z. Standartně povolený pohyb je pouze v ose x a y. Pro změnu os nebo omezení pohybu jen v některých osách lze použít tyto klávesy:
Shift | osa X
Ctrl | osa Y
Shift + Ctrl | osa Z

Funkce Snap je součástí funkce Move a aktivuje se klávesou N. Tato funkce umožňuje krokovat objekty vůči mřížce nebo vertexům, hranám či trojúhelníkům a to jak vybraných tak nevybraných objektů.

Grid point, Vertex, Edge, Face | jednotlivé typy krokování
Use axis constraints | přepínačomezování os při krokování
Snap Dist. | vzdálenost v bodech na obrazovce do které krokování reaguje na typy

Rychlost pohybu objektu po scéně lze nastavit klávesou 1 až 0.

Pozice vybraných objektů jze také nastavit číselně v záložce Transform. Pozice jsou v metrech.

Rotace objektu

menu | : edit / transform / rotate
toolbar | : rotate selected
klávesa | : R

Funkce Rotate se po přepnutí do ní aktivuje držením levého tlačítka myši (LMB).

Po její aktivaci je možné vybrané objekty otáčet pohybem myši v osách x, y a z. Standartně je nastavená osa z. Pro změnu osy lze použít tyto klávesy:
X | osa X
Y | osa Y
Z | osa Z

Další horké klávesy jsou:
Ctrl | přepínač rotování podle společné osy nebo samostatných
Shift | přepínač používání světových nebo lokálních os
, | otočí vybraný objekt o 45° proti směru hodinových ručiček (CCW) v ose nastavené pro funkci rotace, pro použití této klávesy není nutné mít aktivní funkci rotace
. | otočí vybraný objekt o 45° ve směru hodinových ručiček (CW) v ose nastavené pro funkci rotace, pro použití této klávesy není nutné mít aktivní funkci rotace

Rotaci vybraných objektů jze také nastavit číselně v záložce Transform. Rotace je ve stupních.

Měřítko objektu - scale

menu | : edit / transform / scale
toolbar | : scale selected
klávesa | : C

Funkce Scale se po přepnutí do ní aktivuje držením levého tlačítka myši (LMB).

Po její aktivaci je možné vybraným objektům měnit měřítko pohybem myši v osách x, y a z nebo uniformě. Standartně je nastaveno uniformní měřítko [image]. Pro změnu os lze použít tyto klávesy:
U | uniformní měřítko
X | osa X
Y | osa Y
Z | osa Z

Měřítko vybraných objektů jze také nastavit číselně v záložce Transform. Měřítko je v procentech.

Výběr objektů ve scéně


Výběr objektů ve scéně

Vybrané objekty je možno uložit do pojmenované skupiny.
Tyto skupiny se používají na mnoha místech pro ulehčení práce s editorem.

Výběr myší

toolbar | : select
klávesa | : S

Zapnutím funkce Select je možno levým tlačítkem myši (LMB) vybírat objekty pro další editaci.
Držením a tažením myší v okně je možné vybírat více objektů současně. Vybere se každý objekt, který se nachází uvnitř zvoleného obdélníku.

Rychlí výběr myší

klávesa : `

Funkce rychlý výběr se zapíná držením klávesy `. Jde ji použít bez zrušení poslední použité funkce editoru. Levým tlačítkem myši (LMB) je pak možno vybírat objekty pro další editaci.
Držením a tažením myší v okně je možné vybírat více objektů současně. Vybere se každý objekt, který se nachází uvnitř zvoleného obdélníku.

Výběr podle jména

menu | : edit / select dialog
klávesa | : HOME

Pro hledání podle části názvu se používá plná hvězdičková konvence. Pokud například budete hledat objekt, který se jmenuje NJK_licuala01, je nutná zápis NJK_licuala01*. Stejně tak je možné napsat *licuala*.

Create | vytvoření skupiny z vybraných objektů
Overwrite | přepsání existující skupiny vybranými objekty
Delete | smazání skupiny
Select | výběr objektů ze skupiny
Add to selected | přidání objeků ze skupiny do aktuálního výběru

Skupiny výběrů


Zarovnávání - Align

toolbar | : align
klávesa | : ctrl+a

Funkce Align umožňuje zarovnávat vybrané objekty podle zvoleného vzoru, a to jak pozici, tak rotaci a měřítko.

Po její aktivaci je nutné zvolit vzor, podle kterého se bude zarovnání provádět.
Po zvolení vzoru se zobrazí dialog, ve kterém je již možné žádané transformace provádět.

Výběr objektů ve scéně


Záložka Database

menu | : view \ editor panel \ database
panel | : database
klávesa | : k

Tato záložka je určena ke vkládání objketů do scény.

Seznam je rozdělen do tří částí.
- current level: obsahuje soubory modelů aktuální scény
- special objects: knihovna speciálních objektů
- package: soubory modelů ze hry Vietcong

Databáze modelů se neaktualizuje sama. Pouze oddíl Current level se sám aktualizuje po načtení scény. Pro aktualizaci databáze je nutné kliknout na tlačítko Refresh
Tlačítko Rabuild TexDB aktualizuje texturovou databázi. Tuto databazi je nutné aktualizovat po přidání každého dalšího souboru textury.

Modely do scény lze vložit dvojitým kliknutím na soubor v databázi, klávesou Enter nebo z menu na pravém tlačítku myši (RMB).

Vyměnit již existující model ze scény za jiný z databáze nebo všechny stejného typu lze provést přes menu na pravém tlačítku myši po vybrání objektu ve scéně.

Typy speciálních objektů


Záložka Place

panel : place

Tato záložka nastavuje parametry pro funkci Placeator.

New | vytvoření nové skupiny
Delete | smazání aktuální skupiny

All | vybere všechny objekty v seznamu
None | zruší výběr
Invert | obrátí výběr v seznamu
Add | Otevře dialog pro přidání objektů do seznamu
Remove | smaže objekt ze seznamu

Low | minimální vzdálenost položeného objektu tažením myši
High | maximální vzdálenost položeného objektu tažením myši
Icon scale | velikost kurzoru, kdy 1 je 100%
z-axis | objekty budou vždy pokládány vzpřímeně
face normal | objekty budou pokládány kolmo na rovinu trojúhelníku

X, Y, Z | otočení v jednotlivých osách
Rand | přepínač používání otočení jako náhodného rozmezí -n až +n

X, Y, Z | měřítko v jednotlivých osách
Uni | uniformní měřítko
Rand | přepínač používání měřítka jako náhodného rozmezí -n až +n

X, Y, Z | posun v ose Z
Rand | přepínač používání posunu jako náhodného rozmezí -n až +n

Set default | nastaví základní vlastnosti pokládaných objektů
From selected | nastaví vlastnosti pokládaných objektů podle vybrané sub-entity

Pokládání objektů - Placeator


Záložka Properties

panel | : properties
klávesa | : enter

Tato záložka slouží k editaci vlastností objektů ve scéně.

Typ objektu BES
Typy speciálních objektů


Záložka Scene

panel : scene

Tato záložka je určena pro nastavování základních parametrů scény.

Distance | maximální dohled kamery ve scéně v metrech
Sub-level name | jméno adresáře s daty pro danou scénu \levels\[adresář mapy]\data\[sub-level name]
Scene note | poznámka, která se zobrazuje v dialogu pro otevření scény


Záložka Transform

panel : transform

V této záložce je možné číselně nastavovat transformace objektů.

Transformační funkce


Záložka Help

panel : help

Tato záložka obsahuje pomocné nástroje.

Skupina Selection groups slouží na ukládání výběrů objektů ve scéně pro pozdejší použití.
Skupina Ruler slouží jako informační tabule funkce Pravítko.
Skupina HW Lighting Info je určena pro zjišťování počtu světel, které osvětlují vybraný objekt.

Informace o použití statických světel
Pravítko - ruler
Skupiny výběrů


Informace o použití světel

panel : help / hw lighting info

Tento nástroj je určen pro přesné zjištění počtu statických a dynamických světel, které osvětlují vybrané objekty.
Ptero-Engine II podporuje pouze světla, která využívaní podpory video karet. Tato podpora je však omezena na osm světel, které mohou současně nasvětlovat jeden samostatný objekt. Přednost mají světla statická. Proto se může stát, že při použití většího počtu světel na nasvícení scény přestane při přepnutí do hry fungovat na některých místech třeba baterka. Tímto nástrojem je možno provést kontrolu vybraného místa a upravit zde nasvícení.

Static | počet statických světel osvětlujících objekt
Dynamic | počet dymanických světel osvětlujících objekt
Select static lights | vybere všechna statická světla osvětlující objekt

Speciální objekt - Light


Skupiny výběrů

panel : help / selection groups

Vybrané objekty je možno uložit do pojmenované skupiny.
Tyto skupiny se používají na mnoha místech pro ulehčení práce s editorem.

Create | vytvoření skupiny z vybraných objektů
Overwrite | přepsání existující skupiny vybranými objekty
Delete | smazání skupiny
Select | výběr objektů ze skupiny
Add to selected | přidání objeků ze skupiny do aktuálního výběru

Pokládání objektů - Placeator
Pokládání objektů - Parachute
Výběr objektů ve scéně


Záložka LMs

panel : lms

Nástroj pro počítání světelných map a stínového stromu.

Regenerate | Přepočítání dat pro světelné mapy
Compute selected | otevře dialog pro nastavení počítání světelných map na vybrané objekty
Compute all | otevře dialog pro nastavení počítání světelných map na všechny objekty ve scéně
Delete selected | smaže světelné mapy vybraných objektů
Delete all | smaže světelné mapy všech objektů ve scéně
Export | otevře dialog pro nastavení počítání stínového stromu pro celou scénu
Export selected | otevře dialog pro nastavení počítání stínového stromu pro vybranou část scény
Save obstacles | umožní uložit do souboru *.obs informace o vybraných objektech, které mají vrhat stín nebo ohraničují plochu pro stínový strom pro pozdější použití
Update grow.dat | pokud jsou ve scéně použité grow objekty, je možné tímto tlačítkem předpočítat jejich nasvětlení

Počítání stínového stromu
Počítání světelných map
Používání kolizního materiálu - typy grow objektů


Počítání stínového stromu

Stínový strom je pomocná mřížka ve 3D prostoru kolem celé scény nebo její vybrané části. Každá takto vzniklá buňka si nese informaci o intenzitě světla, včetně vržených stínů.
Tyto předpočítané data se používaní pro nasvětlování dynamických objektů ve scéně, jako jsou např. hráči, zbraně, grow objekty, ...

Soubor *.shm se nachází v adrasáři:

\levels\[adresář mapy]\data\[sub-level adresář]\ldt

Dialog pro nastavení počítání stínového stromu

panel | : lms / export
panel | : lms / export selected

Density | hustota sítě v metrech ve všech třech osách
Density X | hustota sítě v metrech pouze v ose x, je nutné zapnout přepínačem za číslem
Density Y | hustota sítě v metrech pouze v ose y, je nutné zapnout přepínačem za číslem
Density Z | hustota sítě v metrech pouze v ose z, je nutné zapnout přepínačem za číslem
Reverse casting | přepínač určující, jestli trojúhelníky mají být brány do výpočtu jako oboustranné nebo jednostranné
Draw progress on screen | přepínač vykreslování výpočtu jednotlivých vrstev na monitoru
X res. | vypočtený rozměr sítě v ose x
Y res. | vypočtený rozměr sítě v ose y
Z res. | vypočtený rozměr sítě v ose z
Required memory | předpokládané využití paměti pro výpočet

Informace o použití světel
Subentity - nastavení detailnosti světelných map
Záložka LMs


Počítání světelných map

Světelná mapa je textura, jež je aplikována na model. Tato textura je počítána z průběhu světelných paprsků.
Data světelných map se ukládají do souborů *.ldt.

Ukázka světelné mapy části terénu scény, na které je stín vrtulníku.

Ukázka scény s použitím světelných map.

Ukázka scény bez použití světelných map.

Soubory *.ldt se nachází v adrasáři:

\levels\[adresář mapy]\data\[sub-level adresář]\ldt

Použitím světelné mapy na objekt je také možno snížit počet světel, které objekt nasvětlují. Neboť všechna statická světla, která ovlivňují objekt se při použití mapy již znovu neaplikují. Aplikují se pouze dynamická světla ve hře.

Dialog pro nastavení počítání světelných map

panel | : lms / compute selected
panel | : lms / compute all

Load Obstacles | načtení datového souboru *.obs s informacemi o objektech vrhajících stín není nutné používat, v případě že tento soubor není specifikován, provádí se výpočet ze všech objektů ve scéně
Global size multiplier | násobitel detailnosti map doporučená hodnota je mezi 0.5 - 1
Vertex | vzdálenostní tolerance, podle které se určuje jestli dva sousední trojúhelníky mají krajní body na stejném místě pokud výpočet světelné mapy na hraně dvou trojúhelníků není přesný, doporučujeme tuto hodnotu zvednout, např. na hodnotu 0.05
Normal | tolerance mezi normálami dvou sousedních trojúhelníků, podle které se určuje jestli dva sousední trojúhelníky jsou vůči sobě v jedné rovině pokud výpočet světelné mapy dvou sousedních trojúhelníků není přesný, doporučujeme tuto hodnotu zvednout, např. na hodnotu 0.1
Don't divide groups | přepínač uřčující, jestli sousední trojúhelníky, které jsou v jedné rovině, mají být brány do výpočtu jako jeden mnohoúhelník nebo samostatně
Reverse casting | přepínač určující, jestli trojúhelníky mají být brány do výpočtu jako oboustranné nebo jednostranné
Minimal side size | minimální délka strany trojúhelníku na světelné mapě v bodech pokud by výsledné mapy velkých trojúhelníků byly rozmazané, doporučujeme tuto hodnotu zvednout

Subentity - nastavení detailnosti světelných map
Záložka LMs


Automatické zálohy

Nastavení automatických záloh

cesta : \levels\[adresář mapy]\backup\[sub-level adresář]\

Automatické zálohy se provádí při ukládání scény uživatelem a to do adresáře:
\levels\[adresář mapy]\backup\[sub-level adresář]\

Tyto zálohovací soubory jsou tři a tento systém nemá žádné nastavení.

cesta | : | \levels\[adresář mapy]\backup\
menu | : | settings / editor settings / level backuping
klávesa | : | ctrl + e

Časové zálohy je možné nastavit v dialogu Editor setting. Tyto zálohy se ukládají do adresáře:
\levels\[adresář mapy]\backup\

Těchto zálohovacích souborů může být nastaveno až devět.

enable backuping | přepínač používání časového zálohování scény
backuping time | časování automatického ukládání
backuping files count | počet souborů pro časové automatické ukládání

Obnovení souborů z automatických záloh

Soubory automatických záloh musí být před načtením do editoru přesunuty do adresáře scény:
\levels\[adresář mapy]\

V opačném případě editor nenalezne potřebná data pro Vaši scénu.


Klávesové zkratky

Výběr objektu a transformace
` | rychlý výběr
C | měřítko
M | posun
N | posun - krokování
N+shift | nastavení krokování
Q | zapnutí výběru pro sub-entity
R | rotace
S | výběr
S / ` +ctrl | přidání do výběru
S / ` +shift | odebrání z výběru

Dialogy pro práci s objekty ve scéně
F | dialog pro zamrazení objektů ve scéně
F +shift | dialog pro rozmrazení objektů ve scéně
H+ctrl | dialog pro výběr zobrazení typů objektů ve scéně
Home | dialog pro výběr objektu
Home +shift | dialog pro skrytí objektů
Home +ctrl | dialog pro odkrytí objektů

Funkční klávesy
F1 | uložení Level.tga
F2 | uložení snímku ze hry
F3 | přepínač zobrazení textury #1 (pouze pro editaci)
F3 +ctrl | přepínač zobrazení textury #2 (pouze pro editaci)
F3 +shift | přepínač zobrazení textury #3 (pouze pro editaci)
F4 | přepínač zobrazení reflexní textury (pouze pro editaci)
F4 +shift | přepínač zobrazení vodní kolizní scény (pouze ve hře)
F5 | přepínač zobrazení objektů (pouze ve hře)
F5 +ctrl | přepínač zobrazení Grow objektů (pouze ve hře)
F5 +shift | přepínač zobrazení postav (pouze ve hře)
F6 | přepínač zobrazení kolizních objektů (pouze ve hře)
F6 +ctrl | přepínač zobrazení deště (pouze ve hře)
F6 +shift | přepínač zobrazení FPV zbraně (pouze ve hře)
F7 | přepínač zobrazení stínových map (pouze pro editaci)
F7 +ctrl | přepínač používání mlhy (pouze pro editaci)
F8 | přepínání editor / hra
F11 +ctrl | přepínač filtrování textur (pouze pro editaci)
F11 +ctrl | přepínač mipmapingu (pouze pro editaci)
F12 +ctrl | zobrazení Debug okna pro scripty (pouze ve hře)
F12 +shift | zobrazení vlastností hráče (pouze ve hře)

Ostatní klávesy
1-0 | rychlost pohybu transformačních funkcí
A | asociace objektu se sektorem
C | přepínání kamer - pouze ve hře
D | kopie vybraných objektů
Del | smazání vybraných objektů
E | výběr aktuálního sektoru
E+ctrl | dialog nastavení editoru
End | kamera se přiblíží k vybranému objektu a otočí se na něj
End +ctrl | kamera se pouze otočí na vybraný objekt
End +shift | pohled z vrchu na vybraný objekt
Enter | otevření záložky Vlastnosti
Enter num. | Zamčení pozice kamery pro rendrování.
G +ctrl | přepínač pomocné sítě pro AI
H | skrýt vybrané objekty
H +shift | zobrazit skryté objekty
I+ctrl | přepínač zobrazení profilových informací
Insert | vložení objektu Dummy do scény a přilinkování k němu vśech vybraných objektů
K | otevření záložky Databáze
L | přepínač pomocného světla (pouze pro editaci)
L +shift | povolení baterky ve hře (pouze pro vývoj)
N+ctrl | založení nové scény
O | placeator
O+ctrl | otevření existující scény
P | linkování
R+ctrl | znovu načtení bitmap
S+ctrl | uložení aktuální scény
S +shift | podívat se na Slunce
T | parachute
V+ctrl | přepínač pomocné dohlednosti (pouze pro editaci)
W | přepínač zobrazení drátových modelů
W +ctrl | přepínač zobrazení cest mezi Waypointy
Y+ctrl | vpřed o krok v historii
Z+ctrl | zpět o krok v historii


Předdefinované typy EAX

0 | standartní
1 | malá ozvěna
2 | hory 1
3 | úzký prostor
6 | sklep
7 | hliněný tunel
8 | hory 2
11 | džungle
12 | kaňon
13 | tunel 1
14 | tunel 2
15 | tunel 3
16 | tunel 4
20 | studna
23 | plechová místnost
23 | místnost

Speciální objekt - Sound switch


Typy a podmínky používaných bitmap

Základní typy bitmap

Typy podporovaných bitmapvých souborů jsou:
*.dds
*.tga
*.bmp

U velikosti bitmap je nutné dodržovat konvenci mocniny 2. Minimální velikost bitmapy je 4x4 a maximální 2048x2048 bodů.
Tato omezení jsou dána využíváním technologie DirectX. Proto není možné používat textury s rozlišením např. 640x480 bodů.
Možné rozměry textur jsou:

š \ v | 4 | 8 | 16 | 32 | 64 | 128 | 256 | 512 | 1024 | 2048
4 |  |  |  |  |  |  |  |  |  |
8 |  |  |  |  |  |  |  |  |  |
16 |  |  |  |  |  |  |  |  |  |
32 |  |  |  |  |  |  |  |  |  |
64 |  |  |  |  |  |  |  |  |  |
128 |  |  |  |  |  |  |  |  |  |
256 |  |  |  |  |  |  |  |  |  |
512 |  |  |  |  |  |  |  |  |  |
1024 |  |  |  |  |  |  |  |  |  |
2048 |  |  |  |  |  |  |  |  |  |

V souborech *.bes není informace o umístění těchto souborů. Textury by měly být uloženy v adresáři:

\levels\[adresář mapy]\tex

Engine používá při načítání textur prioritu typu bitmap. Bitmapa *.dds má největší prioritu. To znamená, že pokud najde dvě textury stejného jména, jednu typu *.dds a druhou např. *.bmp, použije typ *.dds.

Seznam textur IFL

Soubor IFL je textový soubor obsahující názvy textur a parametr #interval.
Měl by být uložen u ostatních textur v adresáři:
\levels\[adresář mapy]\tex

Tentou soubor se používá pro definici seznamu textur tvořících spolu animaci. Parametr #interval, který může být umístěn kdekoliv v seznamu i víckrát, pak udává rychlost změny jednotlivých snímků.

Příklad zápisu souboru voda.ifl:

#interval float interval změny jednotlivých snímků

Používání texturového materiálu


Typy podporovaných MP her

Typy MP her

ATG | Assaul team game
CooP | Cooperative game
CTF | Capture the flag
DM | Deathmatch
LMS | Last man standing
RW | Real war
TDM | Team deathmatch
TT | Turn Table

Typy scriptů MP her

atg_killall_u.c | Assaul team game, tým, který přežije, vyhrává
atg_pilot_u.c | Assaul team game, US pilot se musí dostat na LZ
atg_usbomb_u.c | Assaul team game, US pokládají bombu, VC brání
atg_vcbomb_u.c | Assaul team game, VC pokládají bombu, US brání
ctf_u.c | Capture the flag
dm_u.c | Deathmatch
rw_u.c | Real war
tdm_u.c | Team deathmatch

Definice MP her
Speciální objekt - MP helper
Speciální objekt - Recovery point
Speciální objekt - Spectator camera


Příprava modelů ve 3ds max 5.1

Definovatelné vlastnosti objektů
Exportování do formátu BES
Používání PteroMateriálu
Vytvoření efektových koulí
Vytvoření kolizního tvaru objektu
Vytvoření struktury LOD


Exportování do formátu BES

Před exportem scény je nutné všechny objekty převést do 'Editable mesh' a provést 'Reset XForm'. 'Reset XForm' se nachází v Command panelu, v záložce Utilities. Jedná se o nevratnou akci, proto je dobré si před exportem scény práci uložit.

menu | : file / export... / bes
menu | : file / export selected... / bes (*.bes)

Name | jméno počítače a uživatele - nelze měnit
Comment | poznámka, kterou je možné číst v editoru v záložce Database
Resmooth single objects | přepočítání úhlů sousedních normál objektů - není nutné používat
Smooth whole scene | přepínač aplikace parametru Smooth v User defined vlastnostech objektů
Distinguish LODs | používá se pro export postav při zapnutí Smooth whole scene

panel : utilities / more... / BES export

Export! | provede export scény
Run Engine | spustí PteroEngine - musí být nastavená cesta
Resmooth objects | přepočítání úhlů sousedních normál objektů - není nutné používat
Smooth scene | přepínač aplikace parametru Smooth v User defined vlastnostech objektů
Distinguish LODs | používá se pro export postav při zapnutí Smooth whole scene
Export selected only | export pouze vybraných objektů
Comment | poznámka, kterou je možné číst v editoru v záložce Database
Export filename | celá cesta i s názvem souboru BES
Path to engine | celá cesta k PteroEnginu
Run engine | přepínač spouštění enginu a načtení vyexportovaného soubory *.bes


Vytváření efektových koulí

Efektové koule tvoří speciální kolizní systém. Používají se především u rostlin. Umožňují nastavit zpomalení hráče při jejím průchodu a typ kolizního materiálu.
Doporučujeme tento systém u rostlin používat neboť je mnohem rychlejší než klasické kolize.

Efektová koule vznikne jako vepsaná koule do dummy
Na změnu velikosti se nesmí používat neuniformní měřítko.
Tento dummy nemusí být k ničemu přilinkován.

Efektová koule se vytváří pomocí dummy objektu, jehož jméno je složeno z:

@[materiál][zpomalení]- + text

materiál | dva velké znaky typu materiálu
zpomalení | číslo v rozmezí 0-9 0 = žádné zpomalení 9 = skoro zastavení

Pokud tedy použijeme kolizní materiál JL, což je listí, a zpomalení 3 vznikne nám název: @JL3-


Vytváření kolizních tvarů

Engine podporuje tři typy kolizních tvarů:
1. automatické
2. definované
3. pomocné

Automatické kolize

Tyto kolize jsou vytvářeny pokud je hodnota Phy_colshp a Phy_misshp nastavena na 1 až 3 nebo pokud je vyplněný kolizní materiál v PteroMat.

Engine si po načtení modelu vytvoří kolizní tvary pro pohyb hráče a pro střelbu.

Pokud je vyplněn kolizní materiál v PteroMat, oba vytvořené tvary jsou totožné s grafickým tvarem. Zde již není nutné nastavovat Phy_colshp nebo Phy_misshp na 2.

U malých objektů jako jsou například sklenice doporučujeme nastavit Phy_colshp nebo Phy_misshp na 3. Výpočet tohoto kolizního tvaru je mnohem rychlejší než klasické kolizní tvary.
Pokud je nastaven Phy_colshp nebo Phy_misshp na 1 nebo 3 je nutné vyplnit i Phy_defmat.

Příklad zápisu:

Definové kolize

Objekty definovaných kolizních tvarů musí mít na prvním místě v názvu ^K, ^SF nebo ^SK.
Je možné kombinovat automatické a definované kolize. Pokud například chcete vytvořit upravené kolize pro hráče, přilinkujete objekt ^K k hlavnímu objektu. Tvar pro střelbu si pak engine, pokud je definovaný kolizní materál v PteroMat, vytvoří sám.

Kolize se vytváří pouze pro hlavní objekt, nikoliv pro jeho LOD objekty.

Kolizní materiály se na ně aplikují pomocí PteroMat.

Doporučujeme vytvářet definované kolize pro hráče se zjednodušeným tvarem. Podstatně se tím zrychlí hra.

Pomocné kolize

Objekty pomocných kolizních tvarů musí mít na prvním místě v názvu vykřičník (!). Není nutné je linkovat k žádnému jinému objektu.

Kolizní materiály se na něj aplikují pomocí PteroMat.

Konvence jmen definovaných kolizních tvarů
^K + text | tvar pro hráče
^SF + text | tvar pro střelbu
^SK + text | pouze pro dummy - definuje vepsanou kouli v dummy
! + text | pomocná kolize

Definice typu kolizí
Používání kolizního materiálu


Vytváření sektorů, portálů a ocluderů

Vytváření sektorů

Sektor je ohraničená oblast, která může mít jedinečné vlastnosti, jak grafické, tak zvukové.

Je tvořen grafickým tvarem, který musí mít normály otočené směrem dovnitř. Jeho tvar nemusí být konvexní.
Může mít libovolný počet portálů nebo ocluderů. Portály musí být přilinkovany na odpovídající sektor.

Schéma spojení sektoru a portálů:

Objekty asociované na sektor se kreslí pouze, je-li do sektoru videt. To znamená, pokuď je alespoň jeden jeho portál otevřený nebo je kamera uvnitř sektoru.
Sektor může být přilinkován na d.o.

Objekt sektor musí mít vyplněno v Object properties:

Vytváření portálů

Portál je útvar tvořený trojúhelníky, který musí přesně kopírovat tvar sektoru v místě svého umístění. Jeho normály musí být otočené dovnitř.
Musí být přilinkován na příslušný sektor.

Objekt portál musí mít vyplněno v Object properties:

Vytváření okluderů

Okluder je jakýkoliv útvar tvořený trojúhelníky. Nemusí být přilinkován na žádný objekt, ale může být přilinkován i na d.o.
Objekty, které mají nastavený occluding design a portály se za ním nekreslí.

Objekt okluder musí mít vyplněno v Object properties:

Ocluder, Portal, Sector - MAX
Ocluder
Portal
Sector


Vytváření žebříků

Žebřík je složen z hlavního modelu, zjednodušené kolize pro panáka (^K) a čtyř dummy objektů (BL, BR, TL, TR).

Hlavní objekt má PteroMat s vyplněným kolizním materiálem, ze kterého se vytváří kolizní objekt pro střely.
Kolizní objekt pro panáka (^K) je tvořen hranolem o velikosti vnějšího rozměru žebříku. Pouze v horní části musí tato kolize končit na úrovní posledního stupně.

Schéma přilinkování pomocných objektů na hlavní model:

Jednotlivé stupně žebříku musí být od sebe vzdáleny 0,3 metru.

Pomocné dummy objekty určují místo nástupu (na prvním stupni) a výstupu (na posledním).
Tyto dummy musí být pojmenovány podle umístění na žebříku při čelním pohledu, a to:
BL | spodní vlevo
BR | spodní vpravo
TL | horní vlevo
TR | horní vpravo

Nástupní strana na žebřík je v tomto případě čelní.

Hlavní objekt musí mít nastaven parametr:

Vytváření kolizních tvarů


Vytváření struktury LOD

Level of Detail (LOD) se využívá ke snížení grafických detailů modelů a tím značného zrychlení vykreslování ve hře.

Objekty, které tvoří LODy hlavního objektu musí být nalinkovány k hlavnímu objektu podle tohoto grafu, který zobrazuje hlavní objekt se dvěma LOD objekty:

Jméno každého LOD objektu musí začínat znakem '>'.
Relativní umístění modelu LOD objektů k hlavnímu se určuje podle pozice pivot bodu.
Doporučené množství LOD objektů je 1 až 3.

Hlavní objekt musí mít vyplněné parametry Lod, popřípadě LastLodAlpha.
Parametrů Lod je nutno vyplnit o jeden více než je LOD objektů.

Při nastavování Level of Detail je možné použít i parametr AlphaMult.

Příklady zápisu:

Tento příklad ukazuje zápis, kdy má hlavní objekt dva objekty LOD. První se přepne ve vzdálenosti 25 metrů a druhý ve vzdálenosti 50 metrů. Poslední parametr Lod má hodnotu -1. To znamená, že poslední LOD objekt zůstane zobrazen dokud nebude za dohledností scény.

Tento příklad ukazuje zápis, kdy má poslední parametr Lod hodnotu rovnu 75. To znamená, že poslední LOD objekt se ve zdálenosti 75 metrů přestane vykreslovat.

Zde jsme do zápisu přidali ještě parametr LastLodAlpha. To znamená, že poslední LOD objekt se do vzdálenosti 75 metrů přestane, za použití průhlednosti, postupně vykreslovat.

AlphaMult, ClipDist, Dol, DolNoAlpha
LastLodAlpha, Lod
Objekt dummy v LOD struktuře


Objekt dummy v LOD struktuře

Objekt dummy byl do struktury LOD přidán z důvodu nutnosti lodování více na sobě nezávislých objektů ve stejný moment.

Objekty, které tvoří hlavní objekty musí být nalinkovány k dummy podle tohoto grafu. LOD objekty jsou také linkovány na tento dummy:

Schéma ukazuje dummy 'House', na který jsou nalinkovány grafické objekty 'House - roof' a 'House - wall'. V User defined vlastnostech dummy je zápis:

Je to zápis, který by v klasickém případě obsahoval hlavní objekt LOD struktury.
Objekty '>House LOD01' a '>House LOD02' jsou již LOD objekty, které se podle vzdáleností vymění za objekty bez znaku '>' v názvu.

Toto schéma zobrazuje použití objektu dummy jak hlavního, tak i jako LOD objektu. I na LOD dummy je možné přilinkovat větší množství grafických objektů.

Vytváření struktury LOD


Definovatelné vlastnosti objektů

Quad menu : properties / user defined

Tyto parametry slouží k přednastavení vlastností objektů pro editor a hru. Je s nimi možno nastavovat nasvětlení objektů, fyziku a jiné.

AlphaMult, ClipDist, Dol, DolNoAlpha
Fyzika
LastLodAlpha, Lod
Lighting, Smooth, TexMove, TexPing, Wobble
Ocluder, Portal, Sector


AlphaMult, ClipDist, Dol, DolNoAlpha - MAX

Quad menu : properties / user defined

AlphaMult= val

- násobitel vzdálenosti průhlednosti
val rozmezí = 0 až 1
základní hodnota = 0.8

ClipDist= dist

- vzdálenost v metrech objektu od kamery, ve které se přestává vykreslovat i s celou hierarchií pod ním
- tento parametr doporučujeme používat pro optimalizaci zobrazování objektů ve scéně
- pro optimalizaci je možné i ve 3ds Max využívat pomocný objekt Dummy stejně jako v editoru

Dol= dist

- parametr nastavující vzdálenost v metrech od kamery, ve které je objekt plně vidět

DolNoAlpha= 1

- přepínač mizení objektu s parametrem Dol bez použití průhlednosti

Speciální objekt - Dummy


Fyzika - MAX

Quad menu : properties / user defined

Pro správnou funkčnost fyziky je nutné vyplnit všechny parametry.

Phy_density= val
- hustota objektu

Phy_moment= val
- moment setrvačnosti

Phy_status= id
- typ fyzikálních vlastností objektu

id:
0 | objekt koliduje, nesynchronizuje se při síťové hře
1 | objekt koliduje, synchronizuje se při síťové hře
2 | nekoliduje s fyzik. objekty, koliduje s hráčem a AI, synchronizuje se
3 | nekoliduje s fyzik. objekty, nesynchronizuje se

Phy_weight= val
- váha objektu


Kolize - MAX

Quad menu : properties / user defined

Phy_colshp= val
- typ kolizního tvaru pro hráče, umělou inteligenci a fyziku
0 | přilinkovaný tvar - automaticky se nastaví, pokud export nalezne objekt ^K
1 | vytvoří opsaný kvádr kolem objektu
2 | vytvoří kolize z grafického tvaru - automaticky se nastaví, pokud je vypněný kolizní materiál v PteroMat a není již nastavena 0
3 | vytvoří opsanou kouli kolem objektu

Phy_misshp= val
- typ kolizního tvaru pro střelbu
0 | přilinkovaný tvar - automaticky se nastaví, pokud export nalezne objekt ^SF nebo ^SK
1 | vytvoří opsaný kvádr kolem objektu
2 | vytvoří kolize z grafického tvaru - automaticky se nastaví, pokud je vypněný kolizní materiál v PteroMat a není již nastavena 0
3 | vytvoří opsanou kouli kolem objektu

Phy_defmat= mat
- typ kolizního materiálu
- je nutné vypňovat pouze pokud je hodnota u Phy_colshp a Phy_misshp nastavena na 1 nebo 3

Phy_WPObstacle= 1
- přepínač rušení spojů way pointů objektem

Vytváření kolizních tvarů


LastLodAlpha, Lod - MAX

Quad menu : properties / user defined

LastLodAlpha= 1
- přepínač používání postupného mizení posledního Lod objektu

Lod= dist
- tato vlastnost umožňuje přepínání LOD objektů podle vzdálenosti objektu od kamery
dist vzdálenost, na které se přepne další LOD objektu,
pokud dist je rovna -1, poslední LOD se nevypne

Vytváření struktury LOD


Lighting, Smooth, TexMove, TexPing, Wobble - MAX

Quad menu : properties / user defined

Lighting= ambient_mult, directional_mult, r, g, b

- všechny vrcholy objektu mají stejné osvětlení
- toto nasvětlení se vypočítá jako násobek ambientu + násobek směrového světla + barva
- je nutné vyplňovat u Grow objektů
ambient_mult | násobek ambientního světla sektoru
directional_mult | násobek směrového světla sektoru
r, g, b | barevné složky světla

Smooth= angle, group1, ..., groupN

- používá se k vyhlazování na dotekových hranách různých objektů se stejným indexem skupiny
- výpočet se provádí při exportu do formátu BES
angle | úhel pro vyhlazení normál
group1, ..., groupN | skupiny objektů

TexMove= tex_id, delta_u, delta_v

- posun textury po objektu
- je možno nastavit pro jednotlivé textury
tex_id | ID textury: 0 - diffuse #1 1 - diffuse #2 2 - diffuse #3
delta_u, delta_v | posun v jednotlivých osách za 1 vteřinu

TexPing= tex_id, u_time, u_min, u_max, u_soft, v_time, v_min, v_max, v_soft

- posun textury po objektu - typ ping pong
- je možno nastavit pro jednotlivé textury
tex_id | ID textury: 0 - diffuse #1 1 - diffuse #2 2 - diffuse #3
u_time, v_time | čas jednoho pohybu textury tam a zpět pro jednotlivé osy
u_min, u_max, v_min, v_max | interval posunu pro jednotlivé osy
u_soft, v_soft | typ dorazu při změně směru pro jednotlivé osy: 0 - tvrdá změna směru 1 - měkká změna směru

Wobble= AltX, AltY, AltX, SpeedX, SpeedY, SpeedZ

- tato vlastnost umožňuje pohyb objektu kolem pivot bodu
- používá se především na rostliny
- doporučené hodnoty mohou být: 2.8, 3.1, 2.5 , 2.1, 1.6, 2.2
AltX, AltY, AltZ | výchylka kymácení ve stupních
SpeedX, SpeedY, SpeedZ | rychlost kymácení


Ocluder, Portal, Sector - MAX

Quad menu : properties / user defined

Ocluder= 1

- objekt s tímto parametrem je zastiňovací objekt pro portály a rendrovací objekty
- tento objekt je možno použít uvnitř sektoru například do zdí

Portal= active_dist, half_dist, fade_dist, r, g, b

active_dist | vzdálenost portálu od kamery do které je otevřený
half_dist | vzdálenost portálu od kamery od které se vykreslují pouze objekty přilinkované k sektoru ve 3ds Max
fade_dist | vzdálenost portálu od kamery ve které se portál začne obarvovat, pokud hodnota je rovna 0, portál se zavře bez použití zatmavování do nastavené barvy
r, g, b | jednotlivé složky barvy zavřeného portálu

Sector= 1

- objekt s tímto parametrem tvoří hranice sektoru

Ocluder
Portal
Sector
Vytváření sektorů, portálů a ocluderů


Používání PteroMateriálu

PteroMateriál je speciálně vytvořený plug-in pro 3ds Max 5.1, který umožňuje jednoduše používat a nastavovat právě ty vlastnosti materiálů, jenž jsou nutné pro PteroEngine II. Jedná se o nástavbu standartního texturovacího materiálu.

Používání texturového materiálu
Používání kolizního materiálu


PteroMaterial - textury

Používání texturového materiálu

PteroMateriál - vlastnosti

  1. Použité textury
    • 1 - přepínač používání Textury č. 1, která se používá jako základní
    • 2 - přepínač používání Textury č. 2, která se používá jako detailní
    • 3 - přepínač používání Textury č. 3, která se používá jako překrývací za pomocí jejího alfa kanálu
    • L - přepínač používání Mapy stínů
    • M - přepínač používání Environmentu

  2. Typ průhlednosti
    • žádná - neprůhledné
    • typ 0 - transparentní, ukládá se do z-bufferu, třídí se
    • typ 1 - transparentní, ukládá se do z-bufferu, třídí se, 2-bitový alfa kanál
    • typ 2 - translucentní, NEukládá se do z-bufferu, třídí se
    • typ 3 - transparentní, ukládá se do z-bufferu, NEtřídí se, 2-bitový alfa kanál
    • typ 4 - translucentní, přičítá se k pozadí, NEukládá se do z-bufferu, třídí se

  3. Oboustranné použítí materiálu při rendrování

Textura č.1, č.3 a mapa stínů

E | přepínač používání textury
M | přepínač používání degradace textury dle vzdálenosti (mipmaping)
U | přepínač používání opakování textury v ose U
V | přepínač používání opakování textury v ose V
Ch | číslo mapovacího kanálu (1-99)
i | tlačítko na zrušení instance textury
u | tlačítko na zrušení textury
r | tlačítko na znovu načtení textury
s | tlačítko na zobrazení textury na modelu
a | tlačítko na zobrazení alfa kanálu textury na modelu
t | tlačítko na zobrazení průhledné textury na modelu
  • poznámka: u tlačítka `s`, `a`, `t` je nutno mít v Material Editoru zapnuté i zobrazování materiálu na modelu ( [image] )

    • Textura č.2

    E | přepínač používání textury
M | přepínač používání degradace textury dle vzdálenosti (mipmaping)
U | přepínač používání opakování textury v ose U
V | přepínač používání opakování textury v ose V
T | počet opakování textury (1-999)
Ch | číslo mapovacího kanálu (1-99)
i | tlačítko na zrušení instance textury
u | tlačítko na zrušení textury
r | tlačítko na znovu načtení textury
s | tlačítko na zobrazení textury na modelu
a | tlačítko na zobrazení alfa kanálu textury na modelu
t | tlačítko na zobrazení průhledné textury na modelu
  • poznámka: u tlačítka `s`, `a`, `t` je nutno mít v Material Editoru zapnuté i zobrazování materiálu na modelu ( [image] )

    • Environmentální mapa

    E | přepínač používání textury
M | přepínač používání degradace textury dle vzdálenosti (mipmaping)
1 | standartní typ použití
2 | mapa se aplikuje podle svého alfa kanálu
Ch | číslo mapovacího kanálu (1-99)
i | tlačítko na zrušení instance textury
u | tlačítko na zrušení textury
r | tlačítko na znovu načtení textury
s | tlačítko na zobrazení textury na modelu
  • poznámka: u tlačítka `s` je nutno mít v Material Editoru zapnuté i zobrazování materiálu na modelu ( [image] )

    • Používání kolizního materiálu
    Typy a podmínky používaných bitmap


Používání kolizního materiálu

PteroKolize - vlastnosti

  1. Kolizní materiál - knihovna materiálů aplikovaných na kolize pro panáka, zvuk, ... Základní materiál je A-, tento by se ale neměl použivat pro finální modely
  2. Typ rostlin - jedná se o jedno písmenný název adresáře v (hra)/levels/(název scény)/data/(název podscény)/grow
  3. Typ trávy - zatím není aplikováno !!!!!!!!!!!!!!!!!!!!!
... | zobrazení dialogu pro nastavení cesty k databázi kolizních materiálů
r | znovu načtení databáze

Používání texturového materiálu
Vytváření Grow objektů


Scripting helper

menu : entities / create / scripting helper
panel : database / special objects / scripting helper ( [image])

Scripting helper je pomocný objekt pro interakci se scripty.

Scriptem je možno se tohoto objektu dotázat na jeho poloměr a podle něj pak kontrolovat pohyb ve scéně.

Základní vlastnosti v záložce Properties

Entity name jméno objektu zobrazované v editoru

Radius vzdálenost v metrech, kterou vrací objekt scriptu

Typy speciálních objektů
Používání objektové databáze